# Calcolo della soluzione di un sistema lineare di n equazioni in n incognite.
# La funzione gauss() accetta la matrice completa che rappresenta il sistema 
# lineare da risolvere e si suppone che il sistema sia determinato
#
# Per esercizio, si puo' modificare il programma in modo che esso sia 
# robusto rispetto a una matrice di ingresso che rappresenta un sistema
# impossibile o indeterminato.
# 
# Questa versione semplificata non scambia due righe se m[i][i] e` nullo.
# Per la versione completa, si veda sistemalin.py
#

def stampa_matrice(m):
	"""Stampa la matrice arrotondando il valore degli elementi in modo 'generale', 
   	ovvero in virgola fissa oppure in formato scientifico (esponenziale)"""

	for i in range(0, len(m)):
		for j in range(0, len(m[i])):
			print('%g'% (m[i][j]), end="\t")
			
		print("")


def diagonale_unitaria(m):
	rows = len(m)
	cols = len(m[0])
		
	for i in range(0, rows):
		mii = m[i][i]
		if mii != 0:
		# altrimenti riga nulla e sistema cala di rango...
			for j in range(0, cols):
				m[i][j] = m[i][j] / mii
		
		
def gauss(m):
	# controllo che la matrice non sia nulla
	if len(m) == 0 or len(m[0]) == 0:
		return "Matrice in input nulla!"
	
	# suppongo matrice valida, ove ogni riga ha lo stesso numero di elementi
	nrows = len(m)
	ncols = len(m[0]) 
	
	for row in range(0, nrows):
		# devo annullare tutti gli elementi delle righe sotto su quella colonna
		next_row = row + 1
			
		while next_row < nrows:
			# calcolo il valore del coefficiente 
			coeff = -m[next_row][row]/m[row][row];
			#
			for column in range(0, ncols):
				m[next_row][column] = m[next_row][column] + coeff * m[row][column];
			
			# prossimo passo, applico il procedimento alla riga successiva
			next_row = next_row + 1
			
			
		# ora serve annullare tutti gli elementi sopra la riga row nella colonna row
		prev_row = row - 1	
		while prev_row >= 0:
			# calcolo il valore del coefficiente 
			coeff = -m[prev_row][row] / m[row][row];
			#
			for column in range(0, ncols):
				m[prev_row][column] = m[prev_row][column] + coeff * m[row][column];
				
			prev_row = prev_row - 1
	

	diagonale_unitaria(m)

	stampa_matrice(m)

# 	se voglio restituire la matrice al chiamante
#	return m
	
	return 0		



	
